/*
IXPostingSet.h
Copyright 1991,NeXT Computer,Inc.
*/

#import	<objc/Object.h>
#import "protocols.h"

#ifndef	RELEASE_2
@interface IXPostingSet: Object <IXPostingExchange, IXPostingOperations>
#else	RELEASE_2
@interface IXPostingSet: Object
#endif	RELEASE_2
{
@public
    unsigned		thisElement;
    unsigned 		numElements;
    unsigned 		maxElements;
    IXPosting		*postings;
}

#ifndef	RELEASE_2
- initWithPostingsIn:(id <IXPostingExchange>)anObject;
#else	RELEASE_2
- initWithPostingsIn:anObject;
#endif	RELEASE_2
- initCount:(unsigned)theCount 
    andPostings:(const IXPosting *)thePostings;

#ifdef	RELEASE_2
- formUnionWithPostingsIn:anObject;
- formIntersectionWithPostingsIn:anObject;
- subtractPostingsIn:anObject;
#else	RELEASE_2
- formUnionWithPostingsIn:(id <IXPostingExchange>)anObject;
- formIntersectionWithPostingsIn:(id <IXPostingExchange>)anObject;
- subtractPostingsIn:(id <IXPostingExchange>)anObject;
#endif	RELEASE_2

- (unsigned)setPosition:(unsigned)aPosition;
- setCount:(unsigned)theCount 
    andPostings:(IXPosting *)thePostings byCopy:(BOOL)aBoolean;

#0f	RELEASE_2

// @protocol IXPostingOperations

- addHandle:(unsigned)handle withWeight:(unsigned)weight;
- removeHandle:(unsigned)handle;

- (unsigned)count;
- empty;

- (unsigned)setFirstHandle;
- (unsigned)setNextHandle;

- (unsigned)setHandle:(unsigned)handle;
- (unsigned)getHandle:(unsigned *)handle 
    andWeight:(unsigned *)weight;

// @protocol IXPostingExchange

- getCount:(unsigned *)theCount andPostings:(IXPosting **)thePostings;
- setCount:(unsigned)theCount andPostings:(const IXPosting *)thePostings;

#endif	RELEASE_2

@end

